# Uses of Interface
org.springframework.http.client.ClientHttpRequest

Packages that use ClientHttpRequest
Package
Description
org.springframework.http.client
Contains an abstraction over client-side HTTP.
org.springframework.http.client.observation
This package provides support for client HTTP `Observation`.
org.springframework.http.client.support
This package provides generic HTTP support classes, to be used by higher-level classes like RestTemplate.
org.springframework.web.client
Core package of the client-side web support.

## Uses of ClientHttpRequest in org.springframework.http.client

Classes in org.springframework.http.client that implement ClientHttpRequest
Modifier and Type
Class
Description
`class`
`AbstractClientHttpRequest`
Abstract base for `ClientHttpRequest` that makes sure that headers and body are not written multiple times.
Methods in org.springframework.http.client that return ClientHttpRequest
Modifier and Type
Method
Description
`final ClientHttpRequest`
AbstractClientHttpRequestFactoryWrapper.`createRequest(URI uri, HttpMethod httpMethod)`
This implementation simply calls `AbstractClientHttpRequestFactoryWrapper.createRequest(URI, HttpMethod, ClientHttpRequestFactory)` with the wrapped request factory provided to the constructor.
`protected abstract ClientHttpRequest`
AbstractClientHttpRequestFactoryWrapper.`createRequest(URI uri, HttpMethod httpMethod, ClientHttpRequestFactory requestFactory)`
Create a new `ClientHttpRequest` for the specified URI and HTTP method by using the passed-on request factory.
`protected ClientHttpRequest`
BufferingClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod, ClientHttpRequestFactory requestFactory)`
`ClientHttpRequest`
ClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
Create a new `ClientHttpRequest` for the specified URI and HTTP method.
`ClientHttpRequest`
HttpComponentsClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
`protected ClientHttpRequest`
InterceptingClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod, ClientHttpRequestFactory requestFactory)`
`ClientHttpRequest`
JdkClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
`ClientHttpRequest`
JettyClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
`ClientHttpRequest`
OkHttp3ClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
Deprecated, for removal: This API element is subject to removal in a future version.
`ClientHttpRequest`
ReactorClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
`ClientHttpRequest`
SimpleClientHttpRequestFactory.`createRequest(URI uri, HttpMethod httpMethod)`
Methods in org.springframework.http.client with parameters of type ClientHttpRequest
Modifier and Type
Method
Description
`void`
ClientHttpRequestInitializer.`initialize(ClientHttpRequest request)`
Initialize the given client HTTP request.

## Uses of ClientHttpRequest in org.springframework.http.client.observation

Constructors in org.springframework.http.client.observation with parameters of type ClientHttpRequest
Modifier
Constructor
Description
``
`ClientRequestObservationContext(ClientHttpRequest request)`
Create an observation context for `ClientHttpRequest` observations.

## Uses of ClientHttpRequest in org.springframework.http.client.support

Methods in org.springframework.http.client.support that return ClientHttpRequest
Modifier and Type
Method
Description
`protected ClientHttpRequest`
HttpAccessor.`createRequest(URI url, HttpMethod method)`
Create a new `ClientHttpRequest` via this template's `ClientHttpRequestFactory`.

## Uses of ClientHttpRequest in org.springframework.web.client

Methods in org.springframework.web.client with parameters of type ClientHttpRequest
Modifier and Type
Method
Description
`void`
RequestCallback.`doWithRequest(ClientHttpRequest request)`
Gets called by `RestTemplate.execute(java.lang.String, org.springframework.http.HttpMethod, org.springframework.web.client.RequestCallback, org.springframework.web.client.ResponseExtractor<T>, java.lang.Object...)` with an opened `ClientHttpRequest`.
Method parameters in org.springframework.web.client with type arguments of type ClientHttpRequest
Modifier and Type
Method
Description
`S`
RestClient.RequestHeadersSpec.`httpRequest(Consumer<ClientHttpRequest> requestConsumer)`
Callback for access to the `ClientHttpRequest` that in turn provides access to the native request of the underlying HTTP library.